Index: explore/beta/sasfit_compare.py
===================================================================
--- explore/beta/sasfit_compare.py	(revision 119073a61da4bc8256d0f33c999a38f346f9dfc6)
+++ explore/beta/sasfit_compare.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -408,5 +408,5 @@
         #radius_effective=12.59921049894873,
         )
-    target = sasmodels_theory(q, model, effective_radius_mode=0, structure_factor_mode=1, **pars)
+    target = sasmodels_theory(q, model, radius_effective_mode=0, structure_factor_mode=1, **pars)
     actual = ellipsoid_pe(q, norm='sasview', **pars)
     title = " ".join(("sasmodels", model, pd_type))
Index: explore/beta/sasfit_compare_new.py
===================================================================
--- explore/beta/sasfit_compare_new.py	(revision b6422c70e7f1518835a0b3c12f01bccb859a6999)
+++ explore/beta/sasfit_compare_new.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -360,5 +360,5 @@
 #polydispersity for hollow_cylinder
 def hollow_cylinder_pe(q,radius=20, thickness=10, length=80, sld=4, sld_solvent=1, volfraction=0.15,
-        radius_pd=0.1, thickness_pd=0.2, length_pd=0.05, radius_pd_type="gaussian", length_pd_type="gaussian", 
+        radius_pd=0.1, thickness_pd=0.2, length_pd=0.05, radius_pd_type="gaussian", length_pd_type="gaussian",
         thickness_pd_type="gaussian", radius_effective=None, background=0, scale=1,
                  norm='sasview'):
@@ -595,5 +595,5 @@
 #       this one is only used locally for "actual"
         )
-    target = sasmodels_theory(q, model, effective_radius_mode=0, structure_factor_mode=1, **pars)
+    target = sasmodels_theory(q, model, radius_effective_mode=0, structure_factor_mode=1, **pars)
     actual = sphere_r(q, norm='sasview', **pars)
     title = " ".join(("sasmodels", model, pd_type))
@@ -612,8 +612,8 @@
         background=0,
         radius_pd=0.01, thickness_pd=0.01, radius_pd_type=pd_type, thickness_pd_type=pd_type,
-        radius_effective=30. ) 
+        radius_effective=30. )
         # equivalent average sphere radius for local "actual" to match what sasview uses, use None to compute average outer radius here,
 
-    target = sasmodels_theory(q, model, effective_radius_mode=0, structure_factor_mode=1, **pars)
+    target = sasmodels_theory(q, model, radius_effective_mode=0, structure_factor_mode=1, **pars)
     actual = vesicle_pe(q, norm='sasview', **pars)
     title = " ".join(("sasmodels", model, pd_type))
@@ -633,7 +633,7 @@
         background=0,
         radius_pd=0.1, thickness_pd=0.0, length_pd=0.0, radius_pd_type=pd_type, thickness_pd_type=pd_type, length_pd_type=pd_type,
-        radius_effective=40.687)  
+        radius_effective=40.687)
         # equivalent average sphere radius for local "actual" to match what sasview uses
-    target = sasmodels_theory(q, model, effective_radius_mode=0, structure_factor_mode=1, **pars)
+    target = sasmodels_theory(q, model, radius_effective_mode=0, structure_factor_mode=1, **pars)
     actual = hollow_cylinder_pe(q, norm='sasview', **pars)
 # RKH monodisp was OK,    actual = hollow_cylinder_theta(q,radius=20, thickness=10, length=80, sld=4, sld_solvent=1 )
@@ -656,5 +656,5 @@
 # if change radius_effective to some other value, the S(Q) from sasview does not agree
         )
-    target = sasmodels_theory(q, model, effective_radius_mode=0, structure_factor_mode=1, **pars)
+    target = sasmodels_theory(q, model, radius_effective_mode=0, structure_factor_mode=1, **pars)
     actual = ellipsoid_pe(q, norm='sasview', **pars)
 # RKH test       actual = ellipsoid_theta(q, radius_polar=20, radius_equatorial=400, sld=4, sld_solvent=1, volfraction=0.15, radius_effective=270.)
Index: sasmodels/conversion_table.py
===================================================================
--- sasmodels/conversion_table.py	(revision fa8e6dcf3e461c78e01fc9879eb87ba90aa8db08)
+++ sasmodels/conversion_table.py	(revision ef476e6b7ffc21ee7a467a47ef19a30527778450)
@@ -854,5 +854,5 @@
             "TwoPowerLawModel",
         ],
-        "unified_power_rg": [
+        "unified_power_Rg": [
             "UnifiedPowerRg",
             dict(((field_new+str(index), field_old+str(index))
Index: sasmodels/convert.py
===================================================================
--- sasmodels/convert.py	(revision fa8e6dcf3e461c78e01fc9879eb87ba90aa8db08)
+++ sasmodels/convert.py	(revision ef476e6b7ffc21ee7a467a47ef19a30527778450)
@@ -606,5 +606,5 @@
             if pars['volfraction_a'] > 0.5:
                 pars['volfraction_a'] = 1.0 - pars['volfraction_a']
-        elif name == 'unified_power_rg':
+        elif name == 'unified_power_Rg':
             pars['level'] = int(pars['level'])
 
Index: sasmodels/core.py
===================================================================
--- sasmodels/core.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
+++ sasmodels/core.py	(revision 9562dd291d339c408b3d9b5e9ec9b50ac5ea3449)
@@ -376,11 +376,11 @@
     # type: () -> None
     """Check that model load works"""
+    from .product import RADIUS_ID, VOLFRAC_ID, STRUCTURE_MODE_ID, RADIUS_MODE_ID
     #Test the the model produces the parameters that we would expect
     model = load_model("cylinder@hardsphere*sphere")
     actual = [p.name for p in model.info.parameters.kernel_parameters]
-    target = ("sld sld_solvent radius length theta phi"
-              " radius_effective volfraction "
-              " structure_factor_mode radius_effective_mode"
-              " A_sld A_sld_solvent A_radius").split()
+    target = ["sld", "sld_solvent", "radius", "length", "theta", "phi",
+              RADIUS_ID, VOLFRAC_ID, STRUCTURE_MODE_ID, RADIUS_MODE_ID,
+              "A_sld", "A_sld_solvent", "A_radius"]
     assert target == actual, "%s != %s"%(target, actual)
 
Index: sasmodels/direct_model.py
===================================================================
--- sasmodels/direct_model.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
+++ sasmodels/direct_model.py	(revision e220acc6e66a35148031748a9408b1ffc4530a38)
@@ -59,7 +59,7 @@
     """
     mesh = get_mesh(calculator.info, pars, dim=calculator.dim, mono=mono)
-    #print("pars", list(zip(*mesh))[0])
+    #print("in call_kernel: pars:", list(zip(*mesh))[0])
     call_details, values, is_magnetic = make_kernel_args(calculator, mesh)
-    #print("values:", values)
+    #print("in call_kernel: values:", values)
     return calculator(call_details, values, cutoff, is_magnetic)
 
@@ -72,11 +72,12 @@
 
     Use parameter *radius_effective_mode* to select the effective radius
-    calculation.
+    calculation to use amongst the *radius_effective_modes* list given in the
+    model.
     """
     R_eff_type = int(pars.pop(RADIUS_MODE_ID, 1.0))
     mesh = get_mesh(calculator.info, pars, dim=calculator.dim, mono=mono)
-    #print("pars", list(zip(*mesh))[0])
+    #print("in call_Fq: pars", list(zip(*mesh))[0])
     call_details, values, is_magnetic = make_kernel_args(calculator, mesh)
-    #print("values:", values)
+    #print("in call_Fq: values:", values)
     return calculator.Fq(call_details, values, cutoff, is_magnetic, R_eff_type)
 
@@ -118,5 +119,5 @@
         active = lambda name: True
 
-    #print("pars",[p.id for p in parameters.call_parameters])
+    #print("in get_mesh: pars:",[p.id for p in parameters.call_parameters])
     mesh = [_get_par_weights(p, values, active(p.name))
             for p in parameters.call_parameters]
Index: sasmodels/generate.py
===================================================================
--- sasmodels/generate.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
+++ sasmodels/generate.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -27,5 +27,5 @@
     which are hollow.
 
-    *effective_radius(mode, p1, p2, ...)* returns the effective radius of
+    *radius_effective(mode, p1, p2, ...)* returns the effective radius of
     the form with particular dimensions.  Mode determines the type of
     effective radius returned, with mode=1 for equivalent volume.
@@ -820,5 +820,5 @@
                               for p in partable.kernel_parameters))
     # Define the function calls
-    call_effective_radius = "#define CALL_EFFECTIVE_RADIUS(_mode, _v) 0.0"
+    call_radius_effective = "#define CALL_RADIUS_EFFECTIVE(_mode, _v) 0.0"
     if partable.form_volume_parameters:
         refs = _call_pars("_v.", partable.form_volume_parameters)
@@ -833,8 +833,8 @@
                 "do { _form = _shell = form_volume(%s); } "
                 "while (0)") % (",".join(refs))
-        if model_info.effective_radius_type:
-            call_effective_radius = (
-                "#define CALL_EFFECTIVE_RADIUS(_mode, _v) "
-                "effective_radius(_mode, %s)") % (",".join(refs))
+        if model_info.radius_effective_modes:
+            call_radius_effective = (
+                "#define CALL_RADIUS_EFFECTIVE(_mode, _v) "
+                "radius_effective(_mode, %s)") % (",".join(refs))
     else:
         # Model doesn't have volume.  We could make the kernel run a little
@@ -845,5 +845,5 @@
             "do { _form = _shell = 1.0; } while (0)")
     source.append(call_volume)
-    source.append(call_effective_radius)
+    source.append(call_radius_effective)
     model_refs = _call_pars("_v.", partable.iq_parameters)
 
Index: sasmodels/kernel.py
===================================================================
--- sasmodels/kernel.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
+++ sasmodels/kernel.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -78,5 +78,5 @@
         """
         _, F2, _, shell_volume, _ = self.Fq(call_details, values, cutoff,
-                                            magnetic, effective_radius_type=0)
+                                            magnetic, radius_effective_mode=0)
         combined_scale = values[0]/shell_volume
         background = values[1]
@@ -85,5 +85,5 @@
 
     def Fq(self, call_details, values, cutoff, magnetic,
-           effective_radius_type=0):
+           radius_effective_mode=0):
         # type: (CallDetails, np.ndarray, np.ndarray, float, bool, int) -> np.ndarray
         r"""
@@ -143,5 +143,5 @@
         volume fraction of the particles.  The model can have several
         different ways to compute effective radius, with the
-        *effective_radius_type* parameter used to select amongst them.  The
+        *radius_effective_mode* parameter used to select amongst them.  The
         volume fraction of particles should be determined from the total
         volume fraction of the form, not just the shell volume fraction.
@@ -153,5 +153,5 @@
         """
         self._call_kernel(call_details, values, cutoff, magnetic,
-                          effective_radius_type)
+                          radius_effective_mode)
         #print("returned",self.q_input.q, self.result)
         nout = 2 if self.info.have_Fq and self.dim == '1d' else 1
@@ -165,5 +165,5 @@
         form_volume = self.result[nout*self.q_input.nq + 1]/total_weight
         shell_volume = self.result[nout*self.q_input.nq + 2]/total_weight
-        effective_radius = self.result[nout*self.q_input.nq + 3]/total_weight
+        radius_effective = self.result[nout*self.q_input.nq + 3]/total_weight
         if shell_volume == 0.:
             shell_volume = 1.
@@ -171,5 +171,5 @@
               if nout == 2 else None)
         F2 = self.result[0:nout*self.q_input.nq:nout]/total_weight
-        return F1, F2, effective_radius, shell_volume, form_volume/shell_volume
+        return F1, F2, radius_effective, shell_volume, form_volume/shell_volume
 
     def release(self):
@@ -181,5 +181,5 @@
 
     def _call_kernel(self, call_details, values, cutoff, magnetic,
-                     effective_radius_type):
+                     radius_effective_mode):
         # type: (CallDetails, np.ndarray, np.ndarray, float, bool, int) -> np.ndarray
         """
Index: sasmodels/kernel_iq.c
===================================================================
--- sasmodels/kernel_iq.c	(revision 8973e0dd01924c3850d3624b5b4a433a0e2893c8)
+++ sasmodels/kernel_iq.c	(revision 8973e0dd01924c3850d3624b5b4a433a0e2893c8)
@@ -27,5 +27,5 @@
 //      parameters in the parameter table.
 //  CALL_VOLUME(form, shell, table) : assign form and shell values
-//  CALL_EFFECTIVE_RADIUS(type, table) : call the R_eff function
+//  CALL_RADIUS_EFFECTIVE(mode, table) : call the R_eff function
 //  CALL_IQ(q, table) : call the Iq function for 1D calcs.
 //  CALL_IQ_A(q, table) : call the Iq function with |q| for 2D data.
@@ -304,5 +304,5 @@
     pglobal double *result,       // nq+1 return values, again with padding
     const double cutoff,          // cutoff in the dispersity weight product
-    int32_t effective_radius_type // which effective radius to compute
+    int32_t radius_effective_mode // which effective radius to compute
     )
 {
@@ -722,6 +722,6 @@
       weighted_form += weight * form;
       weighted_shell += weight * shell;
-      if (effective_radius_type != 0) {
-        weighted_radius += weight * CALL_EFFECTIVE_RADIUS(effective_radius_type, local_values.table);
+      if (radius_effective_mode != 0) {
+        weighted_radius += weight * CALL_RADIUS_EFFECTIVE(radius_effective_mode, local_values.table);
       }
       BUILD_ROTATION();
Index: sasmodels/kernelcl.py
===================================================================
--- sasmodels/kernelcl.py	(revision 069743ad3277819b232d3b3bc5a2e94eb110f106)
+++ sasmodels/kernelcl.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -577,5 +577,5 @@
 
     def _call_kernel(self, call_details, values, cutoff, magnetic,
-                     effective_radius_type):
+                     radius_effective_mode):
         # type: (CallDetails, np.ndarray, float, bool, int) -> np.ndarray
         env = environment()
@@ -601,5 +601,5 @@
             self._result_b,   # Result storage.
             self._as_dtype(cutoff),  # Probability cutoff.
-            np.uint32(effective_radius_type),  # R_eff mode.
+            np.uint32(radius_effective_mode),  # R_eff mode.
         ]
 
Index: sasmodels/kernelcuda.py
===================================================================
--- sasmodels/kernelcuda.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
+++ sasmodels/kernelcuda.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -473,5 +473,5 @@
 
     def _call_kernel(self, call_details, values, cutoff, magnetic,
-                     effective_radius_type):
+                     radius_effective_mode):
         # type: (CallDetails, np.ndarray, float, bool, int) -> np.ndarray
 
@@ -492,5 +492,5 @@
             self._result_b,   # Result storage.
             self._as_dtype(cutoff),  # Probability cutoff.
-            np.uint32(effective_radius_type),  # R_eff mode.
+            np.uint32(radius_effective_mode),  # R_eff mode.
         ]
         grid = partition(self.q_input.nq)
Index: sasmodels/kerneldll.py
===================================================================
--- sasmodels/kerneldll.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
+++ sasmodels/kerneldll.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -403,5 +403,5 @@
 
     def _call_kernel(self, call_details, values, cutoff, magnetic,
-                     effective_radius_type):
+                     radius_effective_mode):
         # type: (CallDetails, np.ndarray, float, bool, int) -> np.ndarray
 
@@ -417,5 +417,5 @@
             self.result.ctypes.data,   # Result storage.
             self._as_dtype(cutoff),  # Probability cutoff.
-            effective_radius_type,  # R_eff mode.
+            radius_effective_mode,  # R_eff mode.
         ]
 
Index: sasmodels/kernelpy.py
===================================================================
--- sasmodels/kernelpy.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
+++ sasmodels/kernelpy.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -172,5 +172,5 @@
         volume = model_info.form_volume
         shell = model_info.shell_volume
-        radius = model_info.effective_radius
+        radius = model_info.radius_effective
         self._volume = ((lambda: (shell(*volume_args), volume(*volume_args))) if shell and volume
                         else (lambda: [volume(*volume_args)]*2) if volume
@@ -180,5 +180,5 @@
                         else (lambda mode: 1.0))
 
-    def _call_kernel(self, call_details, values, cutoff, magnetic, effective_radius_type):
+    def _call_kernel(self, call_details, values, cutoff, magnetic, radius_effective_mode):
         # type: (CallDetails, np.ndarray, np.ndarray, float, bool) -> np.ndarray
         if magnetic:
@@ -186,6 +186,6 @@
         #print("Calling python kernel")
         #call_details.show(values)
-        radius = ((lambda: 0.0) if effective_radius_type == 0
-                  else (lambda: self._radius(effective_radius_type)))
+        radius = ((lambda: 0.0) if radius_effective_mode == 0
+                  else (lambda: self._radius(radius_effective_mode)))
         self.result = _loops(
             self._parameter_vector, self._form, self._volume, radius,
Index: sasmodels/model_test.py
===================================================================
--- sasmodels/model_test.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
+++ sasmodels/model_test.py	(revision 8795b6f853cd54be29051109ba0e616e1b31b673)
@@ -240,4 +240,5 @@
                     s_name = pars.pop('@S')
                     ps_test = [pars] + list(test[1:])
+                    #print("PS TEST PARAMS!!!",ps_test)
                     # build the P@S model
                     s_info = load_model_info(s_name)
@@ -246,4 +247,7 @@
                                            platform=self.platform)
                     # run the tests
+                    #self.info = ps_model.info
+                    #print("SELF.INFO PARAMS!!!",[p.id for p in self.info.parameters.call_parameters])
+                    #print("PS MODEL PARAMETERS:",[p.id for p in ps_model.info.parameters.call_parameters])
                     results.append(self.run_one(ps_model, ps_test))
 
@@ -303,6 +307,7 @@
             """Run a single test case."""
             user_pars, x, y = test[:3]
-            pars = expand_pars(self.info.parameters, user_pars)
-            invalid = invalid_pars(self.info.parameters, pars)
+            #print("PS MODEL PARAMETERS:",[p.id for p in model.info.parameters.call_parameters])
+            pars = expand_pars(model.info.parameters, user_pars)
+            invalid = invalid_pars(model.info.parameters, pars)
             if invalid:
                 raise ValueError("Unknown parameters in test: " + ", ".join(invalid))
@@ -328,30 +333,18 @@
             else:
                 y1 = y
-                y2 = test[3] if not isinstance(test[3], list) else [test[3]]
-                F1, F2, R_eff, volume, volume_ratio = call_Fq(kernel, pars)
-                if F1 is not None:  # F1 is none for models with Iq instead of Fq
-                    self._check_vectors(x, y1, F1, 'F')
-                self._check_vectors(x, y2, F2, 'F^2')
+                y2 = test[3] if isinstance(test[3], list) else [test[3]]
+                F, Fsq, R_eff, volume, volume_ratio = call_Fq(kernel, pars)
+                if F is not None:  # F is none for models with Iq instead of Fq
+                    self._check_vectors(x, y1, F, 'F')
+                self._check_vectors(x, y2, Fsq, 'F^2')
                 self._check_scalar(test[4], R_eff, 'R_eff')
                 self._check_scalar(test[5], volume, 'volume')
                 self._check_scalar(test[6], volume_ratio, 'form:shell ratio')
-                return F2
+                return Fsq
 
         def _check_scalar(self, target, actual, name):
-            if target is None:
-                # smoke test --- make sure it runs and produces a value
-                self.assertTrue(not np.isnan(actual),
-                                'invalid %s: %s' % (name, actual))
-            elif np.isnan(target):
-                # make sure nans match
-                self.assertTrue(np.isnan(actual),
-                                '%s: expected:%s; actual:%s'
-                                % (name, target, actual))
-            else:
-                # is_near does not work for infinite values, so also test
-                # for exact values.
-                self.assertTrue(target == actual or is_near(target, actual, 5),
-                                '%s: expected:%s; actual:%s'
-                                % (name, target, actual))
+            self.assertTrue(is_near(target, actual, 5),
+                            '%s: expected:%s; actual:%s'
+                            % (name, target, actual))
 
         def _check_vectors(self, x, target, actual, name='I'):
@@ -363,19 +356,7 @@
                              '%s(...) returned wrong length'%name)
             for xi, yi, actual_yi in zip(x, target, actual):
-                if yi is None:
-                    # smoke test --- make sure it runs and produces a value
-                    self.assertTrue(not np.isnan(actual_yi),
-                                    'invalid %s(%s): %s' % (name, xi, actual_yi))
-                elif np.isnan(yi):
-                    # make sure nans match
-                    self.assertTrue(np.isnan(actual_yi),
-                                    '%s(%s): expected:%s; actual:%s'
-                                    % (name, xi, yi, actual_yi))
-                else:
-                    # is_near does not work for infinite values, so also test
-                    # for exact values.
-                    self.assertTrue(yi == actual_yi or is_near(yi, actual_yi, 5),
-                                    '%s(%s); expected:%s; actual:%s'
-                                    % (name, xi, yi, actual_yi))
+                self.assertTrue(is_near(yi, actual_yi, 5),
+                                '%s(%s): expected:%s; actual:%s'
+                                % (name, xi, target, actual))
 
     return ModelTestCase
@@ -389,5 +370,8 @@
     invalid = []
     for par in sorted(pars.keys()):
-        # special handling of R_eff mode, which is not a usual parameter
+        # Ignore the R_eff mode parameter when checking for valid parameters.
+        # It is an allowed parameter for a model even though it does not exist
+        # in the parameter table.  The call_Fq() function pops it from the
+        # parameter list and sends it directly to kernel.Fq().
         if par == product.RADIUS_MODE_ID:
             continue
@@ -405,8 +389,29 @@
     """
     Returns true if *actual* is within *digits* significant digits of *target*.
-    """
-    import math
-    shift = 10**math.ceil(math.log10(abs(target)))
-    return abs(target-actual)/shift < 1.5*10**-digits
+
+    *taget* zero and inf should match *actual* zero and inf.  If you want to
+    accept eps for zero, choose a value such as 1e-10, which must match up to
+    +/- 1e-15 when *digits* is the default value of 5.
+
+    If *target* is None, then just make sure that *actual* is not NaN.
+
+    If *target* is NaN, make sure *actual* is NaN.
+    """
+    if target is None:
+        # target is None => actual cannot be NaN
+        return not np.isnan(actual)
+    elif target == 0.:
+        # target is 0. => actual must be 0.
+        # Note: if small values are allowed, then use maybe test zero against eps instead?
+        return actual == 0.
+    elif np.isfinite(target):
+        shift = np.ceil(np.log10(abs(target)))
+        return abs(target-actual) < 1.5*10**(shift-digits)
+    elif target == actual:
+        # target is inf => actual must be inf of same sign
+        return True
+    else:
+        # target is NaN => actual must be NaN
+        return np.isnan(target) == np.isnan(actual)
 
 # CRUFT: old interface; should be deprecated and removed
Index: sasmodels/modelinfo.py
===================================================================
--- sasmodels/modelinfo.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
+++ sasmodels/modelinfo.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -265,5 +265,5 @@
     other sld parameters. The volume parameters are used for calls
     to form_volume within the kernel (required for volume normalization),
-    to shell_volume (for hollow shapes), and to effective_radius (for
+    to shell_volume (for hollow shapes), and to radius_effective (for
     structure factor interactions) respectively.
 
@@ -841,5 +841,5 @@
     info.structure_factor = getattr(kernel_module, 'structure_factor', False)
     # TODO: find Fq by inspection
-    info.effective_radius_type = getattr(kernel_module, 'effective_radius_type', None)
+    info.radius_effective_modes = getattr(kernel_module, 'radius_effective_modes', None)
     info.have_Fq = getattr(kernel_module, 'have_Fq', False)
     info.profile_axes = getattr(kernel_module, 'profile_axes', ['x', 'y'])
@@ -848,5 +848,5 @@
     info.source = getattr(kernel_module, 'source', [])
     info.c_code = getattr(kernel_module, 'c_code', None)
-    info.effective_radius = getattr(kernel_module, 'effective_radius', None)
+    info.radius_effective = getattr(kernel_module, 'radius_effective', None)
     # TODO: check the structure of the tests
     info.tests = getattr(kernel_module, 'tests', [])
@@ -961,5 +961,5 @@
     #: List of options for computing the effective radius of the shape,
     #: or None if the model is not usable as a form factor model.
-    effective_radius_type = None   # type: List[str]
+    radius_effective_modes = None   # type: List[str]
     #: List of C source files used to define the model.  The source files
     #: should define the *Iq* function, and possibly *Iqac* or *Iqabc* if the
@@ -989,5 +989,5 @@
     #: monodisperse approximation for non-dilute solutions, P@S.  The first
     #: argument is the integer effective radius mode, with default 0.
-    effective_radius = None  # type: Union[None, Callable[[int, np.ndarray], float]]
+    radius_effective = None  # type: Union[None, Callable[[int, np.ndarray], float]]
     #: Returns *I(q, a, b, ...)* for parameters *a*, *b*, etc. defined
     #: by the parameter table.  *Iq* can be defined as a python function, or
Index: sasmodels/models/_spherepy.py
===================================================================
--- sasmodels/models/_spherepy.py	(revision 0507e09b26f5789862db8a175d64657cf4f3b829)
+++ sasmodels/models/_spherepy.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -48,6 +48,6 @@
 ----------------------------
 
-* **Author: P Kienzle** 
-* **Last Modified by:** 
+* **Author: P Kienzle**
+* **Last Modified by:**
 * **Last Reviewed by:** S King and P Parker **Date:** 2013/09/09 and 2014/01/06
 * **Source added by :** Steve King **Date:** March 25, 2019
@@ -83,7 +83,7 @@
     return 1.333333333333333 * pi * radius ** 3
 
-def effective_radius(mode, radius):
+def radius_effective(mode, radius):
     """Calculate R_eff for sphere"""
-    return radius
+    return radius if mode else 0.
 
 def Iq(q, sld, sld_solvent, radius):
Index: sasmodels/models/barbell.c
===================================================================
--- sasmodels/models/barbell.c	(revision 99658f6e997e12486269a52113af19f5089e0ef0)
+++ sasmodels/models/barbell.c	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -85,5 +85,5 @@
 
 static double
-effective_radius(int mode, double radius_bell, double radius, double length)
+radius_effective(int mode, double radius_bell, double radius, double length)
 {
     switch (mode) {
Index: sasmodels/models/barbell.py
===================================================================
--- sasmodels/models/barbell.py	(revision 0507e09b26f5789862db8a175d64657cf4f3b829)
+++ sasmodels/models/barbell.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -126,5 +126,5 @@
 source = ["lib/polevl.c", "lib/sas_J1.c", "lib/gauss76.c", "barbell.c"]
 have_Fq = True
-effective_radius_type = [
+radius_effective_modes = [
     "equivalent cylinder excluded volume", "equivalent volume sphere",
     "radius", "half length", "half total length",
Index: sasmodels/models/capped_cylinder.c
===================================================================
--- sasmodels/models/capped_cylinder.c	(revision 99658f6e997e12486269a52113af19f5089e0ef0)
+++ sasmodels/models/capped_cylinder.c	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -107,5 +107,5 @@
 
 static double
-effective_radius(int mode, double radius, double radius_cap, double length)
+radius_effective(int mode, double radius, double radius_cap, double length)
 {
     switch (mode) {
Index: sasmodels/models/capped_cylinder.py
===================================================================
--- sasmodels/models/capped_cylinder.py	(revision 0507e09b26f5789862db8a175d64657cf4f3b829)
+++ sasmodels/models/capped_cylinder.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -146,5 +146,5 @@
 source = ["lib/polevl.c", "lib/sas_J1.c", "lib/gauss76.c", "capped_cylinder.c"]
 have_Fq = True
-effective_radius_type = [
+radius_effective_modes = [
     "equivalent cylinder excluded volume", "equivalent volume sphere",
     "radius", "half length", "half total length",
Index: sasmodels/models/core_multi_shell.c
===================================================================
--- sasmodels/models/core_multi_shell.c	(revision d42dd4a6467163ad6ef165b733218fc2181ec1de)
+++ sasmodels/models/core_multi_shell.c	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -26,5 +26,5 @@
 
 static double
-effective_radius(int mode, double core_radius, double fp_n, double thickness[])
+radius_effective(int mode, double core_radius, double fp_n, double thickness[])
 {
   switch (mode) {
Index: sasmodels/models/core_multi_shell.py
===================================================================
--- sasmodels/models/core_multi_shell.py	(revision 0507e09b26f5789862db8a175d64657cf4f3b829)
+++ sasmodels/models/core_multi_shell.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -108,5 +108,5 @@
 source = ["lib/sas_3j1x_x.c", "core_multi_shell.c"]
 have_Fq = True
-effective_radius_type = ["outer radius", "core radius"]
+radius_effective_modes = ["outer radius", "core radius"]
 
 def random():
Index: sasmodels/models/core_shell_bicelle.c
===================================================================
--- sasmodels/models/core_shell_bicelle.c	(revision 99658f6e997e12486269a52113af19f5089e0ef0)
+++ sasmodels/models/core_shell_bicelle.c	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -60,5 +60,5 @@
 
 static double
-effective_radius(int mode, double radius, double thick_rim, double thick_face, double length)
+radius_effective(int mode, double radius, double thick_rim, double thick_face, double length)
 {
     switch (mode) {
Index: sasmodels/models/core_shell_bicelle.py
===================================================================
--- sasmodels/models/core_shell_bicelle.py	(revision 0507e09b26f5789862db8a175d64657cf4f3b829)
+++ sasmodels/models/core_shell_bicelle.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -165,5 +165,5 @@
           "core_shell_bicelle.c"]
 have_Fq = True
-effective_radius_type = [
+radius_effective_modes = [
     "excluded volume", "equivalent volume sphere", "outer rim radius",
     "half outer thickness", "half diagonal",
